
struct buPolyLayerC
(
	LayerBitset = #(-2147483648,1073741824,536870912,268435456,134217728,67108864,33554432,16777216,0),
	LayerBitsetN = #(2130706432,-1090519040,-553648128,-285212672,-150994944,-83886080,-50331648,-33554432,-16777216),
	LayerActive = 9,
	obj
	,
	fn refresh =
	(
		polyOp.unHideAllFaces obj
		obj.Hide #face flags:LayerBitsetN[LayerActive]
	)
	,
	fn addLayer n =
	(
		if (classof (obj = selection[1]) != editable_poly) or (subObjectLevel != 4) do return()
		local tfl = polyOp.getFacesByFlag obj LayerBitset[n] -- ^[QbgC[̃Zbg
		local afl = if n == 9 then -- ANeBuC[̃Zbg
						polyOp.getFacesByFlag obj 0 mask:LayerBitsetN[9]
					else
						polyOp.getFacesByFlag obj LayerBitset[LayerActive]
		local fl = polyop.getFaceSelection obj
		polyOp.setFaceFlags obj (afl-fl) LayerBitset[LayerActive] mask:LayerBitset[LayerActive]
		polyOp.setFaceFlags obj (tfl+fl) LayerBitset[n] mask:LayerBitset[n] -- fl*afl ΏۂANeBuCɐ
		refresh()
	)
	,
	fn createLayer n =
	(
		if (classof (obj = selection[1]) != editable_poly) or (subObjectLevel != 4) do return()
		local afl = if n == 9 then -- ANeBuC[̃Zbg
						polyOp.getFacesByFlag obj 0 mask:LayerBitsetN[9]
					else
						polyOp.getFacesByFlag obj LayerBitset[LayerActive]
		local fl = polyop.getFaceSelection obj
		if n == 9 then
			polyOp.setFaceFlags obj #{} 0 mask:LayerBitsetN[9] -- NA
		else (
			polyOp.setFaceFlags obj (afl-fl) LayerBitset[LayerActive] mask:LayerBitset[LayerActive]
			polyOp.setFaceFlags obj fl LayerBitset[n] mask:LayerBitset[n] -- VKZbg
		)
		refresh()
	)
	,
	fn setLayer n =
	(
		if classof (obj = selection[1]) != editable_poly do return()
		LayerActive = n
		refresh()
	)
	,
	fn unHideAll =
	(
			if classof (obj = selection[1]) != editable_poly do return()
			polyOp.unHideAllFaces obj
			redrawViews()
	)
	,
	fn btnCheck n =
	(
		if keyboard.altPressed then -- ǉ
			addLayer n
		else if keyboard.controlPressed then -- VKZbg
			createLayer n
		else -- C[I
			setLayer n
	)
)

global buPolyLayer = buPolyLayerC()

